import randomName from '../../../node_modules/.pnpm/@scaleway_random-name@4.0.2/node_modules/@scaleway/random-name/dist/index.js';
import { isJSONObject } from '../../../helpers/json.js';
import { unmarshalDate, unmarshalArrayOfObject } from '../../../helpers/marshalling.js';

// This file was automatically generated. DO NOT EDIT.
// If you have any remark or suggestion do not hesitate to open an issue.
const unmarshalJobDefinition = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'JobDefinition' failed as data isn't a dictionary.`);
  }
  return {
    command: data.command,
    cpuLimit: data.cpu_limit,
    createdAt: unmarshalDate(data.created_at),
    description: data.description,
    environmentVariables: data.environment_variables,
    imageUri: data.image_uri,
    jobDefinitionId: data.job_definition_id,
    jobTimeout: data.job_timeout,
    memoryLimit: data.memory_limit,
    name: data.name,
    projectId: data.project_id,
    region: data.region,
    updatedAt: unmarshalDate(data.updated_at)
  };
};
const unmarshalJobRun = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'JobRun' failed as data isn't a dictionary.`);
  }
  return {
    createdAt: unmarshalDate(data.created_at),
    errorMessage: data.error_message,
    exitCode: data.exit_code,
    jobDefinitionId: data.job_definition_id,
    jobRunId: data.job_run_id,
    region: data.region,
    runDuration: data.run_duration,
    state: data.state,
    terminatedAt: unmarshalDate(data.terminated_at),
    updatedAt: unmarshalDate(data.updated_at)
  };
};
const unmarshalListJobDefinitionsResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListJobDefinitionsResponse' failed as data isn't a dictionary.`);
  }
  return {
    jobDefinitions: unmarshalArrayOfObject(data.job_definitions, unmarshalJobDefinition),
    totalCount: data.total_count
  };
};
const unmarshalListJobRunsResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListJobRunsResponse' failed as data isn't a dictionary.`);
  }
  return {
    jobRuns: unmarshalArrayOfObject(data.job_runs, unmarshalJobRun),
    totalCount: data.total_count
  };
};
const marshalCreateJobDefinitionRequest = (request, defaults) => ({
  command: request.command,
  cpu_limit: request.cpuLimit,
  description: request.description,
  environment_variables: request.environmentVariables !== undefined ? request.environmentVariables : undefined,
  image_uri: request.imageUri,
  job_timeout: request.jobTimeout,
  memory_limit: request.memoryLimit,
  name: request.name || randomName('job'),
  project_id: request.projectId ?? defaults.defaultProjectId
});
const marshalUpdateJobDefinitionRequest = (request, defaults) => ({
  command: request.command,
  cpu_limit: request.cpuLimit,
  description: request.description,
  environment_variables: request.environmentVariables,
  image_uri: request.imageUri,
  job_timeout: request.jobTimeout,
  memory_limit: request.memoryLimit,
  name: request.name
});

export { marshalCreateJobDefinitionRequest, marshalUpdateJobDefinitionRequest, unmarshalJobDefinition, unmarshalJobRun, unmarshalListJobDefinitionsResponse, unmarshalListJobRunsResponse };
